# coding: utf-8


"""
IGNORE:
    Nutanix Objects Storage Management APIs

    Manage Petabytes of Unstructured and Machine-generated data using a software-defined Object Store Service  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_objects_py_client.models.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501
from ntnx_objects_py_client.models.common.v1.config.Metadata import Metadata  # noqa: F401,E501
from ntnx_objects_py_client.models.objects.v4.config.CertificateProjection import CertificateProjection  # noqa: F401,E501
from ntnx_objects_py_client.models.objects.v4.config.ObjectStore import ObjectStore  # noqa: F401,E501
from ntnx_objects_py_client.models.objects.v4.config.State import State  # noqa: F401,E501

class ObjectStoreProjection(ObjectStore):

    """

    :param certificate_projection: (:attr:`certificate_projection`) 
    :type certificate_projection: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'certificate_projection': 'list[objects.v4.config.CertificateProjection]',
        'metadata': 'common.v1.config.Metadata',
        'name': 'str',
        'creation_time': 'datetime',
        'last_update_time': 'datetime',
        'description': 'str',
        'deployment_version': 'str',
        'domain': 'str',
        'region': 'str',
        'num_worker_nodes': 'int',
        'cluster_ext_id': 'str',
        'storage_network_reference': 'str',
        'storage_network_vip': 'common.v1.config.IPAddress',
        'storage_network_dns_ip': 'common.v1.config.IPAddress',
        'public_network_reference': 'str',
        'public_network_ips': 'list[common.v1.config.IPAddress]',
        'total_capacity_gi_b': 'int',
        'state': 'objects.v4.config.State',
        'certificate_ext_ids': 'list[str]',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'certificate_projection': 'certificateProjection',
        'metadata': 'metadata',
        'name': 'name',
        'creation_time': 'creationTime',
        'last_update_time': 'lastUpdateTime',
        'description': 'description',
        'deployment_version': 'deploymentVersion',
        'domain': 'domain',
        'region': 'region',
        'num_worker_nodes': 'numWorkerNodes',
        'cluster_ext_id': 'clusterExtId',
        'storage_network_reference': 'storageNetworkReference',
        'storage_network_vip': 'storageNetworkVip',
        'storage_network_dns_ip': 'storageNetworkDnsIp',
        'public_network_reference': 'publicNetworkReference',
        'public_network_ips': 'publicNetworkIps',
        'total_capacity_gi_b': 'totalCapacityGiB',
        'state': 'state',
        'certificate_ext_ids': 'certificateExtIds',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, certificate_projection=None, metadata=None, name=None, creation_time=None, last_update_time=None, description=None, deployment_version=None, domain=None, region=None, num_worker_nodes=None, cluster_ext_id=None, storage_network_reference=None, storage_network_vip=None, storage_network_dns_ip=None, public_network_reference=None, public_network_ips=None, total_capacity_gi_b=None, state=None, certificate_ext_ids=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ObjectStore.__init__(self, metadata, name, creation_time, last_update_time, description, deployment_version, domain, region, num_worker_nodes, cluster_ext_id, storage_network_reference, storage_network_vip, storage_network_dns_ip, public_network_reference, public_network_ips, total_capacity_gi_b, state, certificate_ext_ids, ext_id, links, tenant_id, *args, **kwargs)
        self.__certificate_projection = None
        self.discriminator = None
        if certificate_projection is not None:
            self.__certificate_projection = certificate_projection

    def _initialize_object_type(self):
        return 'objects.v4.config.ObjectStoreProjection'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def certificate_projection(self):
        """
        

        :type:
             list[ :class:`~ntnx_objects_py_client.models.objects.v4.config.CertificateProjection` ]
        """  # noqa: E501
        return self.__certificate_projection

    @certificate_projection.setter
    def certificate_projection(self, certificate_projection):

        self.__certificate_projection = certificate_projection

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ObjectStoreProjection, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ObjectStoreProjection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

